--- old/usr/src/Makefile.smatch	Mon Aug  5 08:37:45 2019
+++ new/usr/src/Makefile.smatch	Mon Aug  5 08:37:45 2019
@@ -28,7 +28,7 @@
 SMATCH_ARGS += -Wno-old-style-definition
 SMATCH_ARGS += -Wno-strict-prototypes
 SMATCH_ARGS += --fatal-checks
-SMATCH_ARGS += --timeout=120
+SMATCH_ARGS += --timeout=0
 
 CERRWARN += $(SMATCH_ARGS:%=-_smatch=%)
 
--- old/usr/src/boot/lib/libstand/Makefile.inc	Mon Aug  5 08:37:45 2019
+++ new/usr/src/boot/lib/libstand/Makefile.inc	Mon Aug  5 08:37:45 2019
@@ -11,6 +11,7 @@
 
 #
 # Copyright 2016 Toomas Soome <tsoome@me.com>
+# Copyright 2019 Joyent, Inc.
 #
 
 #
@@ -85,6 +86,9 @@
 := CFLAGS += -DBZ_LOADER -DBZ_NO_STDIO -DBZ_NO_COMPRESS
 SRCS +=	libstand_bzlib_private.h
 
+# too hairy
+_inflate.o := SMATCH=off
+
 SRCS +=	_bzlib.c _crctable.c _decompress.c _huffman.c _randtable.c
 OBJS +=	_bzlib.o _crctable.o _decompress.o _huffman.o _randtable.o
 CLEANFILES +=	_bzlib.c _crctable.c _decompress.c _huffman.c _randtable.c
--- old/usr/src/boot/sys/boot/Makefile.inc	Mon Aug  5 08:37:46 2019
+++ new/usr/src/boot/sys/boot/Makefile.inc	Mon Aug  5 08:37:46 2019
@@ -11,6 +11,7 @@
 
 #
 # Copyright 2017 Toomas Soome <tsoome@me.com>
+# Copyright 2019 Joyent, Inc.
 #
 
 # loader.help build needs better awk
@@ -52,6 +53,10 @@
 CCASFLAGS=	-fPIC -Wa,--divide
 ASFLAGS=	--divide
 
+SMATCH_ =
+SMATCH_on =
+SMATCH_off = -_smatch=off
+
 # smatch does not define __amd64 and __amd64__
 SMATCH_amd64=	-_smatch=-D__amd64 -_smatch=-D__amd64__
 
@@ -59,6 +64,8 @@
 #CFLAGS +=	$(SMATCH_ARGS:%=-_smatch=%)
 CFLAGS +=	$(SMOFF:%=-_smatch=--disable=%)
 CFLAGS +=	$(SMATCH_$(MACHINE))
+CFLAGS +=	$(SMATCH_$(SMATCH))
+CFLAGS +=	-_smatch=--timeout=0
 
 COMPILE.S=	$(CC) $(SMATCH_off) $(CCASFLAGS) $(CPPFLAGS) -c
 
--- old/usr/src/boot/sys/boot/efi/libefi/i386/Makefile	Mon Aug  5 08:37:47 2019
+++ new/usr/src/boot/sys/boot/efi/libefi/i386/Makefile	Mon Aug  5 08:37:47 2019
@@ -12,6 +12,7 @@
 #
 # Copyright 2016 Toomas Soome <tsoome@me.com>
 # Copyright 2016 RackTop Systems.
+# Copyright 2019 Joyent, Inc.
 #
 
 MACHINE=	$(MACH)
@@ -23,6 +24,9 @@
 
 CFLAGS +=	-m32
 
+# false positive only with a 64-bit smatch
+SMOFF += uninitialized
+
 CLEANFILES +=	machine x86
 
 $(OBJS): machine x86
--- old/usr/src/boot/sys/boot/libstand/Makefile.com	Mon Aug  5 08:37:47 2019
+++ new/usr/src/boot/sys/boot/libstand/Makefile.com	Mon Aug  5 08:37:48 2019
@@ -11,6 +11,7 @@
 
 #
 # Copyright 2016 Toomas Soome <tsoome@me.com>
+# Copyright 2019 Joyent, Inc.
 #
 
 include $(SRC)/Makefile.master
@@ -27,6 +28,15 @@
 
 CPPFLAGS +=	-I$(SRC)/uts/common
 
+# needs work
+printf.o := SMOFF += 64bit_shift
+
+# too hairy
+_inflate.o := SMATCH=off
+
+# 64-bit smatch false positive :/
+SMOFF += uninitialized
+
 clean: clobber
 clobber:
 	$(RM) $(CLEANFILES) $(OBJS) machine $(LIBRARY)
--- old/usr/src/cmd/ls/Makefile.com	Mon Aug  5 08:37:48 2019
+++ new/usr/src/cmd/ls/Makefile.com	Mon Aug  5 08:37:48 2019
@@ -22,7 +22,7 @@
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# cmd/ls/Makefile.com
+# Copyright 2019 Joyent, Inc.
 #
 
 PROG=		ls
@@ -43,14 +43,14 @@
 
 CFLAGS64 +=	$(CCVERBOSE)
 CPPFLAGS += -D_FILE_OFFSET_BITS=64
-LINTFLAGS64 +=	-errchk=longptr64
 
+# main() can be too hairy
+SMATCH=off
+
 .KEEP_STATE:
 
 all:	$(PROG) $(XPG4) $(XPG6)
 
-lint:	lint_SRCS
-
 clean:
 	$(RM) $(CLEANFILES)
 
@@ -61,7 +61,7 @@
 	$(POST_PROCESS)
 
 %.xpg6: ../%.c
-	$(LINK.c) -o $@ $< $(LDLIBS) 
+	$(LINK.c) -o $@ $< $(LDLIBS)
 	$(POST_PROCESS)
 
 %: ../%.c
--- old/usr/src/cmd/sgs/libld/Makefile.com	Mon Aug  5 08:37:49 2019
+++ new/usr/src/cmd/sgs/libld/Makefile.com	Mon Aug  5 08:37:49 2019
@@ -23,7 +23,7 @@
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# Copyright (c) 2018, Joyent, Inc.
+# Copyright 2019 Joyent, Inc.
 # Copyright 2019 OmniOS Community Edition (OmniOSce) Association.
 
 LIBRARY =	libld.a
@@ -113,6 +113,10 @@
 
 native:=	DYNFLAGS	+= $(CONVLIBDIR)
 
+# too hairy
+pics/sections32.o := SMATCH=off
+pics/sections64.o := SMATCH=off
+
 BLTDEFS =	msg.h
 BLTDATA =	msg.c
 BLTMESG =	$(SGSMSGDIR)/libld
--- old/usr/src/cmd/svc/configd/Makefile	Mon Aug  5 08:37:50 2019
+++ new/usr/src/cmd/svc/configd/Makefile	Mon Aug  5 08:37:50 2019
@@ -24,6 +24,8 @@
 #
 # Copyright 2015 RackTop Systems.
 #
+# Copyright 2019 Joyent, Inc.
+#
 
 MYPROG = svc.configd
 MYOBJS = \
@@ -60,9 +62,12 @@
 CERRWARN += -_gcc=-Wno-unused-variable
 CERRWARN += -_gcc=-Wno-unused-function
 CERRWARN += -_gcc=-Wno-uninitialized
+
+# strange false positive
+SMOFF += free
+
 MYLDLIBS = -lumem -luutil
 LDLIBS	+= -lsecdb -lbsm $(MYLDLIBS)
-LINTFLAGS += -errtags -erroff=E_BAD_FORMAT_ARG_TYPE2 -erroff=E_NAME_DEF_NOT_USED2
 
 CLOBBERFILES +=	$(MYPROG:%=%-native)
 
@@ -125,10 +130,6 @@
 
 clobber:
 
-lint:   lint_SRCS
-
-lint_SRCS:
-
 include ../../Makefile.targ
 
 FRC:
--- old/usr/src/cmd/syseventd/modules/sysevent_conf_mod/Makefile	Mon Aug  5 08:37:50 2019
+++ new/usr/src/cmd/syseventd/modules/sysevent_conf_mod/Makefile	Mon Aug  5 08:37:50 2019
@@ -22,6 +22,8 @@
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright 2019 Joyent, Inc.
+#
 
 LIBRARY =	sysevent_conf_mod
 
@@ -32,11 +34,14 @@
 
 CERRWARN +=	-_gcc=-Wno-uninitialized
 
+# strange smatch false positive
+SMOFF +=       allocating_enough_data
+
 .KEEP_STATE:
 
 all: $(DYNLIB)
 
-install: all 				\
+install: all				\
 	$(ROOTLIBSYSEVENTDIR)		\
 	$(ROOTLIBDIR)			\
 	$(ROOTLIBS)
--- old/usr/src/common/ficl/vm.c	Mon Aug  5 08:37:51 2019
+++ new/usr/src/common/ficl/vm.c	Mon Aug  5 08:37:51 2019
@@ -47,6 +47,10 @@
  * SUCH DAMAGE.
  */
 
+/*
+ * Copyright 2019 Joyent, Inc.
+ */
+
 #include "ficl.h"
 
 #if FICL_ROBUST >= 2
@@ -2165,8 +2169,8 @@
 	char *pad = (char *)vm->pad;
 	s = ficlVmGetWord(vm);
 
-	if (FICL_STRING_GET_LENGTH(s) > FICL_PAD_SIZE)
-		FICL_STRING_SET_LENGTH(s, FICL_PAD_SIZE);
+	if (FICL_STRING_GET_LENGTH(s) >= FICL_PAD_SIZE)
+		FICL_STRING_SET_LENGTH(s, FICL_PAD_SIZE - 1);
 
 	(void) strncpy(pad, FICL_STRING_GET_POINTER(s),
 	    FICL_STRING_GET_LENGTH(s));
--- old/usr/src/lib/libpctx/Makefile.com	Mon Aug  5 08:37:51 2019
+++ new/usr/src/lib/libpctx/Makefile.com	Mon Aug  5 08:37:51 2019
@@ -22,7 +22,7 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
+# Copyright 2019 Joyent, Inc.
 #
 
 LIBRARY = libpctx.a
@@ -33,25 +33,20 @@
 # include library definitions
 include ../../Makefile.lib
 
-LIBS = $(DYNLIB) $(LINTLIB)
-$(LINTLIB) :=	SRCS = ../common/llib-lpctx
+LIBS = $(DYNLIB)
 LDLIBS +=	-lproc -lc
 
 SRCDIR =	../common
 
 CFLAGS +=	$(CCVERBOSE)
-CPPFLAGS += 	-D_REENTRANT -I$(SRCDIR)
+CPPFLAGS +=	-D_REENTRANT -I$(SRCDIR)
 
+# false positive: pctx_run() error: dereferencing freed memory 'pctx'
+SMOFF += free
+
 .KEEP_STATE:
 
 all: $(LIBS)
 
-# x86 and sparc have different alignment complaints (all LINTED).
-# Make lint shut up about suppression directive not used.
-lint := LINTFLAGS += -erroff=E_SUPPRESSION_DIRECTIVE_UNUSED
-lint := LINTFLAGS64 += -erroff=E_SUPPRESSION_DIRECTIVE_UNUSED
-
-lint: lintcheck
-
 # include library targets
 include ../../Makefile.targ
--- old/usr/src/lib/libumem/Makefile.com	Mon Aug  5 08:37:52 2019
+++ new/usr/src/lib/libumem/Makefile.com	Mon Aug  5 08:37:52 2019
@@ -22,7 +22,7 @@
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# Copyright (c) 2019, Joyent, Inc.
+# Copyright 2019 Joyent, Inc.
 #
 
 #
@@ -112,7 +112,7 @@
 CLOBBERFILES += $(CLOBBERFILES_$(CURTYPE))
 
 LIBS_standalone = $(STANDLIBRARY)
-LIBS_library = $(DYNLIB) $(LINTLIB)
+LIBS_library = $(DYNLIB)
 LIBS =	$(LIBS_$(CURTYPE))
 
 MAPFILE_SUPPLEMENTAL_standalone = ../common/stand_mapfile
@@ -128,8 +128,6 @@
 ASFLAGS_library =
 ASFLAGS += -P $(ASFLAGS_$(CURTYPE)) -D_ASM
 
-$(LINTLIB) := SRCS = ../common/$(LINTSRC)
-
 # We want the thread-specific errno in the library, but we don't want it in
 # the standalone.  $(DTS_ERRNO) is designed to add -D_TS_ERRNO to $(CPPFLAGS),
 # in order to enable this feature.  Conveniently, -D_REENTRANT does the same
@@ -157,13 +155,11 @@
 CFLAGS64_standalone = $(STAND_FLAGS_64)
 CFLAGS64 += $(CCVERBOSE) $(CFLAGS64_$(CURTYPE)) $(CFLAGS64_common)
 
-INSTALL_DEPS_library =		$(ROOTLINKS) $(ROOTLINT) $(ROOTLIBS)
+# false positive for umem_alloc_sizes_add()
+pics/umem.o := SMOFF += index_overflow
+objs/umem.o := SMOFF += index_overflow
 
-#
-# turn off ptr-cast warnings, since we do them all the time
-#
-LINTFLAGS +=	-erroff=E_BAD_PTR_CAST_ALIGN
-LINTFLAGS64 +=	-erroff=E_BAD_PTR_CAST_ALIGN
+INSTALL_DEPS_library =		$(ROOTLINKS) $(ROOTLIBS)
 
 DYNFLAGS +=     $(ZINTERPOSE)
 
--- old/usr/src/tools/smatch/Makefile	Mon Aug  5 08:37:52 2019
+++ new/usr/src/tools/smatch/Makefile	Mon Aug  5 08:37:52 2019
@@ -13,7 +13,7 @@
 
 #
 # The src/ sub-directory is un-modified copy of
-# https://github.com/illumos/smatch/tree/0.5.1-il-3
+# https://github.com/illumos/smatch/tree/0.5.1-il-4
 #
 # This Makefile installs just enough for us to be able to run smatch
 # locally.
@@ -20,7 +20,7 @@
 #
 
 PROG = smatch
-SPARSE_VERSION = 0.5.1-il-3
+SPARSE_VERSION = 0.5.1-il-4
 
 include ../Makefile.tools
 
@@ -28,7 +28,7 @@
 i386_CC = $(GNUC_ROOT)/bin/gcc
 sparc_CC = $(GNUC_ROOT)/bin/gcc
 
-CFLAGS = -O -D__sun -Wall -Wno-unknown-pragmas -std=gnu99 -nodefaultlibs
+CFLAGS = -O -m64 -msave-args -D__sun -Wall -Wno-unknown-pragmas -std=gnu99 -nodefaultlibs
 
 SMATCHDATADIR = $(ROOTONBLDSHARE)/smatch
 
@@ -77,7 +77,7 @@
 	smatch_mtag_map.o smatch_mtag_data.o \
 	smatch_param_to_mtag_data.o smatch_mem_tracker.o smatch_array_values.o \
 	smatch_nul_terminator.o smatch_assigned_expr.o smatch_kernel_user_data.o \
-	smatch_statement_count.o
+	smatch_statement_count.o smatch_bits.o smatch_integer_overflow.o
 
 OBJS += target.o parse.o tokenize.o pre-process.o symbol.o lib.o scope.o \
 	expression.o show-parse.o evaluate.o expand.o inline.o linearize.o \
--- old/usr/src/tools/smatch/src/Makefile	Mon Aug  5 08:37:53 2019
+++ new/usr/src/tools/smatch/src/Makefile	Mon Aug  5 08:37:53 2019
@@ -1,4 +1,4 @@
-VERSION=0.5.1
+VERSION=0.5.1-il-4
 
 # Generating file version.h if current version has changed
 SPARSE_VERSION:=$(shell git describe 2>/dev/null || echo '$(VERSION)')
@@ -90,7 +90,7 @@
 	smatch_mtag_map.o smatch_mtag_data.o \
 	smatch_param_to_mtag_data.o smatch_mem_tracker.o smatch_array_values.o \
 	smatch_nul_terminator.o smatch_assigned_expr.o smatch_kernel_user_data.o \
-	smatch_statement_count.o
+	smatch_statement_count.o smatch_integer_overflow.o smatch_bits.o
 
 SMATCH_CHECKS=$(shell ls check_*.c | sed -e 's/\.c/.o/')
 SMATCH_DATA=smatch_data/kernel.allocation_funcs \
--- old/usr/src/tools/smatch/src/check_64bit_shift.c	Mon Aug  5 08:37:53 2019
+++ new/usr/src/tools/smatch/src/check_64bit_shift.c	Mon Aug  5 08:37:53 2019
@@ -16,9 +16,40 @@
  */
 
 #include "smatch.h"
+#include "smatch_extra.h"
 
 static int my_id;
 
+static void match_shift_mask(struct expression *expr)
+{
+	struct expression *right, *shifter;
+	struct range_list *rl;
+	char *str;
+
+	expr = strip_expr(expr);
+	if (expr->type != EXPR_BINOP || expr->op != '&')
+		return;
+
+	if (get_type(expr->left) != &ullong_ctype)
+		return;
+
+	if (type_bits(get_type(expr->right)) == 64)
+		return;
+
+	right = strip_expr(expr->right);
+	if (right->type != EXPR_BINOP || right->op != SPECIAL_LEFTSHIFT)
+		return;
+
+	shifter = strip_expr(right->right);
+	get_real_absolute_rl(shifter, &rl);
+	if (rl_max(rl).uvalue < 32)
+		return;
+
+	str = expr_to_str(expr->right);
+	sm_warning("should '%s' be a 64 bit type?", str);
+	free_string(str);
+}
+
 static void match_shift_assignment(struct expression *expr)
 {
 	struct symbol *left_type, *right_type;
@@ -63,4 +94,5 @@
 	my_id = id;
 
 	add_hook(&match_shift_assignment, ASSIGNMENT_HOOK);
+	add_hook(&match_shift_mask, BINOP_HOOK);
 }
--- old/usr/src/tools/smatch/src/check_buffer_too_small_for_struct.c	Mon Aug  5 08:37:54 2019
+++ new/usr/src/tools/smatch/src/check_buffer_too_small_for_struct.c	Mon Aug  5 08:37:54 2019
@@ -26,6 +26,8 @@
 	struct symbol *left_type, *right_type;
 	struct expression *size_expr;
 	sval_t min_size;
+	int limit_type;
+	int bytes;
 
 	left_type = get_type(expr->left);
 	if (!left_type || left_type->type != SYM_PTR)
@@ -43,9 +45,15 @@
 	if (right_type != &void_ctype && type_bits(right_type) != 8)
 		return;
 
-	size_expr = get_size_variable(expr->right);
+	bytes = get_array_size_bytes(expr->right);
+	if (bytes >= type_bytes(left_type))
+		return;
+
+	size_expr = get_size_variable(expr->right, &limit_type);
 	if (!size_expr)
 		return;
+	if (limit_type != ELEM_COUNT)
+		return;
 
 	get_absolute_min(size_expr, &min_size);
 	if (min_size.value >= type_bytes(left_type))
@@ -62,6 +70,7 @@
 	char *name;
 	struct expression *size_expr;
 	sval_t min_size;
+	int limit_type;
 
 	if (expr->type != EXPR_PREOP)
 		return;
@@ -79,9 +88,11 @@
 		return;
 
 	right = get_assigned_expr(expr);
-	size_expr = get_size_variable(right);
+	size_expr = get_size_variable(right, &limit_type);
 	if (!size_expr)
 		return;
+	if (limit_type != ELEM_COUNT)
+		return;
 
 	get_absolute_min(size_expr, &min_size);
 	if (min_size.value >= type_bytes(left_type))
--- /dev/null	Mon Aug  5 08:37:55 2019
+++ new/usr/src/tools/smatch/src/check_cmn_err.c	Mon Aug  5 08:37:55 2019
@@ -0,0 +1,52 @@
+/*
+ * Copyright (C) 2016 Oracle.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see http://www.gnu.org/copyleft/gpl.txt
+ *
+ * Copyright 2019 Joyent, Inc.
+ */
+
+/*
+ * Heavily borrowed from check_wine.c: what we're doing here is teaching smatch
+ * that cmn_err(CE_PANIC, ...) is noreturn.
+ */
+
+#include "scope.h"
+#include "smatch.h"
+#include "smatch_extra.h"
+
+#define	CE_PANIC (3)
+
+void match_cmn_err(const char *fn, struct expression *expr,
+			void *unused)
+{
+	struct expression *arg;
+	sval_t sval;
+
+	arg = get_argument_from_call_expr(expr->args, 0);
+	if (!get_implied_value(arg, &sval))
+		return;
+
+	if (sval.value == CE_PANIC)
+		nullify_path();
+}
+
+
+void check_cmn_err(int id)
+{
+	if (option_project != PROJ_ILLUMOS_KERNEL)
+		return;
+
+	add_function_hook("cmn_err", &match_cmn_err, NULL);
+}
--- old/usr/src/tools/smatch/src/check_debug.c	Mon Aug  5 08:37:55 2019
+++ new/usr/src/tools/smatch/src/check_debug.c	Mon Aug  5 08:37:55 2019
@@ -19,6 +19,11 @@
 #include "smatch_slist.h"
 #include "smatch_extra.h"
 
+void show_sname_alloc(void);
+void show_data_range_alloc(void);
+void show_ptrlist_alloc(void);
+void show_sm_state_alloc(void);
+
 int local_debug;
 static int my_id;
 char *trace_variable;
@@ -198,7 +203,7 @@
 static void match_user_rl(const char *fn, struct expression *expr, void *info)
 {
 	struct expression *arg;
-	struct range_list *rl;
+	struct range_list *rl = NULL;
 	char *name;
 
 	arg = get_argument_from_call_expr(expr->args, 0);
@@ -384,6 +389,7 @@
 	int elements, bytes;
 	char *name;
 	char buf[256] = "";
+	int limit_type;
 	int n;
 	sval_t sval;
 
@@ -392,7 +398,7 @@
 	elements = get_array_size(arg);
 	bytes = get_array_size_bytes_max(arg);
 	rl = get_array_size_bytes_rl(arg);
-	comp = get_size_variable(arg);
+	comp = get_size_variable(arg, &limit_type);
 
 	name = expr_to_str(arg);
 	n = snprintf(buf, sizeof(buf), "buf size: '%s' %d elements, %d bytes", name, elements, bytes);
@@ -403,7 +409,7 @@
 
 	if (comp) {
 		name = expr_to_str(comp);
-		snprintf(buf + n, sizeof(buf) - n, "[size_var=%s]", name);
+		snprintf(buf + n, sizeof(buf) - n, "[size_var=%s %s]", limit_type_str(limit_type), name);
 		free_string(name);
 	}
 	sm_msg("%s", buf);
@@ -504,16 +510,6 @@
 	local_debug = 0;
 }
 
-static void match_debug_implied_on(const char *fn, struct expression *expr, void *info)
-{
-	option_debug_implied = 1;
-}
-
-static void match_debug_implied_off(const char *fn, struct expression *expr, void *info)
-{
-	option_debug_implied = 0;
-}
-
 static void match_about(const char *fn, struct expression *expr, void *info)
 {
 	struct expression *arg;
@@ -644,11 +640,12 @@
 	struct expression *arg;
 	char *name;
 	mtag_t tag = 0;
+	int offset = 0;
 
 	arg = get_argument_from_call_expr(expr->args, 0);
 	name = expr_to_str(arg);
-	get_mtag(arg, &tag);
-	sm_msg("mtag: '%s' => tag: %lld", name, tag);
+	expr_to_mtag_offset(arg, &tag, &offset);
+	sm_msg("mtag: '%s' => tag: %llu %d", name, tag, offset);
 	free_string(name);
 }
 
@@ -666,6 +663,22 @@
 	free_string(name);
 }
 
+static void match_container(const char *fn, struct expression *expr, void *info)
+{
+	struct expression *container, *x;
+	char *cont, *name, *str;
+
+	container = get_argument_from_call_expr(expr->args, 0);
+	x = get_argument_from_call_expr(expr->args, 1);
+
+	str = get_container_name(container, x);
+	cont = expr_to_str(container);
+	name = expr_to_str(x);
+	sm_msg("container: '%s' vs '%s' --> '%s'", cont, name, str);
+	free_string(cont);
+	free_string(name);
+}
+
 static void match_state_count(const char *fn, struct expression *expr, void *info)
 {
 	sm_msg("state_count = %d\n", sm_state_counter);
@@ -754,8 +767,6 @@
 	add_function_hook("__smatch_debug_off", &match_debug_off, NULL);
 	add_function_hook("__smatch_local_debug_on", &match_local_debug_on, NULL);
 	add_function_hook("__smatch_local_debug_off", &match_local_debug_off, NULL);
-	add_function_hook("__smatch_debug_implied_on", &match_debug_implied_on, NULL);
-	add_function_hook("__smatch_debug_implied_off", &match_debug_implied_off, NULL);
 	add_function_hook("__smatch_intersection", &match_intersection, NULL);
 	add_function_hook("__smatch_type", &match_type, NULL);
 	add_implied_return_hook("__smatch_type_rl_helper", &match_type_rl_return, NULL);
@@ -766,6 +777,7 @@
 	add_function_hook("__smatch_state_count", &match_state_count, NULL);
 	add_function_hook("__smatch_mem", &match_mem, NULL);
 	add_function_hook("__smatch_exit", &match_exit, NULL);
+	add_function_hook("__smatch_container", &match_container, NULL);
 
 	add_hook(free_old_stree, AFTER_FUNC_HOOK);
 	add_hook(trace_var, STMT_HOOK_AFTER);
--- old/usr/src/tools/smatch/src/check_debug.h	Mon Aug  5 08:37:56 2019
+++ new/usr/src/tools/smatch/src/check_debug.h	Mon Aug  5 08:37:56 2019
@@ -74,4 +74,6 @@
 
 static inline void __smatch_state_count(void){}
 static inline void __smatch_mem(void){}
+
+static inline void __smatch_container(long long container, long long x){}
 #endif
--- old/usr/src/tools/smatch/src/check_dma_mapping_error.c	Mon Aug  5 08:37:56 2019
+++ new/usr/src/tools/smatch/src/check_dma_mapping_error.c	Mon Aug  5 08:37:56 2019
@@ -32,6 +32,12 @@
 
 static void match_assign(const char *fn, struct expression *expr, void *unused)
 {
+	struct range_list *rl;
+
+	if (!get_implied_rl(expr->right, &rl))
+		return;
+	if (rl_max(rl).value != 1)
+		return;
 	set_state_expr(my_id, expr->left, &positive);
 }
 
--- old/usr/src/tools/smatch/src/check_err_ptr_deref.c	Mon Aug  5 08:37:56 2019
+++ new/usr/src/tools/smatch/src/check_err_ptr_deref.c	Mon Aug  5 08:37:56 2019
@@ -222,7 +222,7 @@
 	return_implies_state("IS_ERR_OR_NULL", 0, 0, &match_checked, NULL);
 	return_implies_state("IS_ERR_OR_NULL", 1, 1, &match_err, NULL);
 	return_implies_state("PTR_RET", 0, 0, &match_checked, NULL);
-	return_implies_state("PTR_RET", -4096, -1, &match_err, NULL);
+	return_implies_state("PTR_RET", -4095, -1, &match_err, NULL);
 	register_err_ptr_funcs();
 	add_hook(&match_dereferences, DEREF_HOOK);
 	add_function_hook("ERR_PTR", &match_err_ptr_positive_const, NULL);
--- old/usr/src/tools/smatch/src/check_free_strict.c	Mon Aug  5 08:37:57 2019
+++ new/usr/src/tools/smatch/src/check_free_strict.c	Mon Aug  5 08:37:57 2019
@@ -291,6 +291,38 @@
 	return ret;
 }
 
+static void match_untracked(struct expression *call, int param)
+{
+	struct state_list *slist = NULL;
+	struct expression *arg;
+	struct sm_state *sm;
+	char *name;
+	char buf[64];
+	int len;
+
+	arg = get_argument_from_call_expr(call->args, param);
+	if (!arg)
+		return;
+
+	name = expr_to_var(arg);
+	if (!name)
+		return;
+	snprintf(buf, sizeof(buf), "%s->", name);
+	free_string(name);
+	len = strlen(buf);
+
+	FOR_EACH_MY_SM(my_id, __get_cur_stree(), sm) {
+		if (strncmp(sm->name, buf, len) == 0)
+			add_ptr_list(&slist, sm);
+	} END_FOR_EACH_SM(sm);
+
+	FOR_EACH_PTR(slist, sm) {
+		set_state(sm->owner, sm->name, sm->sym, &ok);
+	} END_FOR_EACH_PTR(sm);
+
+	free_slist(&slist);
+}
+
 void check_free_strict(int id)
 {
 	my_id = id;
@@ -311,4 +343,5 @@
 	add_pre_merge_hook(my_id, &pre_merge_hook);
 
 	select_return_states_hook(PARAM_FREED, &set_param_freed);
+	add_untracked_param_hook(&match_untracked);
 }
--- old/usr/src/tools/smatch/src/check_held_dev.c	Mon Aug  5 08:37:59 2019
+++ new/usr/src/tools/smatch/src/check_held_dev.c	Mon Aug  5 08:37:59 2019
@@ -113,7 +113,7 @@
 		if (token_type(token) != TOKEN_IDENT)
 			return;
 		func = show_ident(token->ident);
-		return_implies_state(func, valid_ptr_min, valid_ptr_max,
+		return_implies_state_sval(func, valid_ptr_min_sval, valid_ptr_max_sval,
 				     &match_returns_held, NULL);
 		return_implies_state(func, 0, 0, &match_returns_null,
 					 NULL);
--- old/usr/src/tools/smatch/src/check_kernel.c	Mon Aug  5 08:38:00 2019
+++ new/usr/src/tools/smatch/src/check_kernel.c	Mon Aug  5 08:38:00 2019
@@ -23,13 +23,19 @@
 #include "smatch.h"
 #include "smatch_extra.h"
 
+static sval_t err_ptr_min;
+static sval_t err_ptr_max;
+static sval_t null_ptr;
+
 static int implied_err_cast_return(struct expression *call, void *unused, struct range_list **rl)
 {
 	struct expression *arg;
 
 	arg = get_argument_from_call_expr(call->args, 0);
-	if (!get_implied_rl(arg, rl))
-		*rl = alloc_rl(ll_to_sval(-4095), ll_to_sval(-1));
+	if (!get_implied_rl(arg, rl)) {
+		*rl = alloc_rl(err_ptr_min, err_ptr_max);
+		*rl = cast_rl(get_type(arg), *rl);
+	}
 	return 1;
 }
 
@@ -78,10 +84,18 @@
 	struct expression *arg;
 	struct smatch_state *pre_state;
 	struct smatch_state *end_state;
+	struct range_list *rl;
 
 	arg = get_argument_from_call_expr(call_expr->args, param);
 	pre_state = get_state_expr(SMATCH_EXTRA, arg);
-	end_state = estate_filter_range(pre_state, ll_to_sval(-4095), ll_to_sval(0));
+	if (estate_rl(pre_state)) {
+		rl = estate_rl(pre_state);
+		rl = remove_range(rl, null_ptr, null_ptr);
+		rl = remove_range(rl, err_ptr_min, err_ptr_max);
+	} else {
+		rl = alloc_rl(valid_ptr_min_sval, valid_ptr_max_sval);
+	}
+	end_state = alloc_estate_rl(rl);
 	set_extra_expr_nomod(arg, end_state);
 }
 
@@ -96,9 +110,9 @@
 
 	arg = get_argument_from_call_expr(call_expr->args, param);
 	pre_state = get_state_expr(SMATCH_EXTRA, arg);
-	rl = alloc_rl(ll_to_sval(-4095), ll_to_sval(0));
+	call_results_to_rl(call_expr, &ptr_ctype, "0,(-4095)-(-1)", &rl);
 	rl = rl_intersection(estate_rl(pre_state), rl);
-	rl = cast_rl(estate_type(pre_state), rl);
+	rl = cast_rl(get_type(arg), rl);
 	end_state = alloc_estate_rl(rl);
 	set_extra_expr_nomod(arg, end_state);
 }
@@ -108,12 +122,18 @@
 {
 	struct expression *arg;
 	struct smatch_state *pre_state;
-	struct smatch_state *new_state;
+	struct range_list *rl;
 
 	arg = get_argument_from_call_expr(call_expr->args, 0);
 	pre_state = get_state_expr(SMATCH_EXTRA, arg);
-	new_state = estate_filter_range(pre_state, sval_type_min(&long_ctype), ll_to_sval(-1));
-	set_extra_expr_nomod(arg, new_state);
+	if (estate_rl(pre_state)) {
+		rl = estate_rl(pre_state);
+		rl = remove_range(rl, err_ptr_min, err_ptr_max);
+	} else {
+		rl = alloc_rl(valid_ptr_min_sval, valid_ptr_max_sval);
+	}
+	rl = cast_rl(get_type(arg), rl);
+	set_extra_expr_nomod(arg, alloc_estate_rl(rl));
 }
 
 static void match_err(const char *fn, struct expression *call_expr,
@@ -121,13 +141,16 @@
 {
 	struct expression *arg;
 	struct smatch_state *pre_state;
-	struct smatch_state *new_state;
+	struct range_list *rl;
 
 	arg = get_argument_from_call_expr(call_expr->args, 0);
 	pre_state = get_state_expr(SMATCH_EXTRA, arg);
-	new_state = estate_filter_range(pre_state, sval_type_min(&long_ctype), ll_to_sval(-4096));
-	new_state = estate_filter_range(new_state, ll_to_sval(0), sval_type_max(&long_ctype));
-	set_extra_expr_nomod(arg, new_state);
+	rl = estate_rl(pre_state);
+	if (!rl)
+		rl = alloc_rl(err_ptr_min, err_ptr_max);
+	rl = rl_intersection(rl, alloc_rl(err_ptr_min, err_ptr_max));
+	rl = cast_rl(get_type(arg), rl);
+	set_extra_expr_nomod(arg, alloc_estate_rl(rl));
 }
 
 static void match_container_of_macro(const char *fn, struct expression *expr, void *unused)
@@ -379,11 +402,36 @@
 	__in_fake_assign--;
 }
 
+bool is_ignored_kernel_data(const char *name)
+{
+	if (option_project != PROJ_KERNEL)
+		return false;
+
+	/*
+	 * On the file I was looking at lockdep was 25% of the DB.
+	 */
+	if (strstr(name, ".dep_map."))
+		return true;
+	if (strstr(name, ".lockdep_map."))
+		return true;
+	return false;
+}
+
 void check_kernel(int id)
 {
 	if (option_project != PROJ_KERNEL)
 		return;
 
+	err_ptr_min.type = &ptr_ctype;
+	err_ptr_min.value = -4095;
+	err_ptr_max.type = &ptr_ctype;
+	err_ptr_max.value = -1l;
+	null_ptr.type = &ptr_ctype;
+	null_ptr.value = 0;
+
+	err_ptr_min = sval_cast(&ptr_ctype, err_ptr_min);
+	err_ptr_max = sval_cast(&ptr_ctype, err_ptr_max);
+
 	add_implied_return_hook("ERR_PTR", &implied_err_cast_return, NULL);
 	add_implied_return_hook("ERR_CAST", &implied_err_cast_return, NULL);
 	add_implied_return_hook("PTR_ERR", &implied_err_cast_return, NULL);
--- old/usr/src/tools/smatch/src/check_kernel_printf.c	Mon Aug  5 08:38:00 2019
+++ new/usr/src/tools/smatch/src/check_kernel_printf.c	Mon Aug  5 08:38:00 2019
@@ -521,6 +521,15 @@
 			fmt[0], tag, vaidx, type_to_str(type));
 }
 
+static void time_and_date(const char *fmt, struct symbol *type, struct symbol *basetype, int vaidx)
+{
+	assert(tolower(fmt[0]) == 't');
+
+	if (fmt[1] == 'R' && !is_struct_tag(basetype, "rtc_time"))
+		sm_error("'%%ptR' expects argument of type struct 'rtc_time', argument %d has type '%s'",
+			 vaidx, type_to_str(type));
+}
+
 static void check_clock(const char *fmt, struct symbol *type, struct symbol *basetype, int vaidx)
 {
 	assert(fmt[0] == 'C');
@@ -756,6 +765,9 @@
 	case 'd':
 		dentry_file(fmt, type, basetype, vaidx);
 		break;
+	case 't':
+		time_and_date(fmt, type, basetype, vaidx);
+		break;
 	case 'C':
 		check_clock(fmt, type, basetype, vaidx);
 		break;
--- old/usr/src/tools/smatch/src/check_list.h	Mon Aug  5 08:38:00 2019
+++ new/usr/src/tools/smatch/src/check_list.h	Mon Aug  5 08:38:00 2019
@@ -53,8 +53,11 @@
 CK(register_impossible)
 CK(register_impossible_return)
 CK(register_strings)
+CK(register_integer_overflow)
+CK(register_integer_overflow_links)
 CK(register_real_absolute)
 CK(register_imaginary_absolute)
+CK(register_bits)
 CK(register_fn_arg_link)
 CK(register_parameter_names)
 CK(register_return_to_param)
@@ -71,8 +74,8 @@
 CK(register_nul_terminator_param_set)
 CK(register_statement_count)
 
+CK(register_kernel_user_data)
 CK(register_kernel_user_data2)
-CK(register_kernel_user_data3)
 
 CK(check_debug)
 
@@ -187,6 +190,7 @@
 CK(check_nospec)
 CK(check_nospec_barrier)
 CK(check_spectre)
+CK(check_spectre_second_half)
 CK(check_implicit_dependencies)
 
 /* wine specific stuff */
@@ -195,6 +199,7 @@
 
 /* illumos specific */
 CK(check_all_func_returns)
+CK(check_cmn_err)
 
 #include "check_list_local.h"
 
